diff --git a/web/pgadmin/browser/collection.py b/web/pgadmin/browser/collection.py
index 97f58b6..804e8b3 100644
--- a/web/pgadmin/browser/collection.py
+++ b/web/pgadmin/browser/collection.py
@@ -76,10 +76,10 @@ class CollectionNodeModule(PgAdminModule, PGChildModule):
             obj.setdefault(key, kwargs[key])
         return obj
 
-    def generate_browser_collection_node(self, parent_id, **kwargs):
+    def generate_browser_collection_node(self, parent_id, collection_count, **kwargs):
         obj = {
             "id": "coll-%s/%d" % (self.node_type, parent_id),
-            "label": self.collection_label,
+            "label": self.collection_label + ' (' + str(collection_count) + ')',
             "icon": self.collection_icon,
             "inode": True,
             "_type": 'coll-%s' % (self.node_type),
diff --git a/web/pgadmin/browser/server_groups/__init__.py b/web/pgadmin/browser/server_groups/__init__.py
index faff488..63c38e5 100644
--- a/web/pgadmin/browser/server_groups/__init__.py
+++ b/web/pgadmin/browser/server_groups/__init__.py
@@ -21,7 +21,7 @@ from pgadmin.utils.ajax import make_json_response, \
     make_response as ajax_response
 from pgadmin.utils.menu import MenuItem
 
-from pgadmin.model import db, ServerGroup
+from pgadmin.model import db, ServerGroup, Server
 
 
 class ServerGroupModule(BrowserPluginModule):
@@ -33,9 +33,14 @@ class ServerGroupModule(BrowserPluginModule):
             user_id=current_user.id
         ).order_by("id")
         for idx, group in enumerate(groups):
+
+            # Find number of servers in this group
+            servers = Server.query.filter_by(user_id=current_user.id,
+                                             servergroup_id=group.id)
+
             yield self.generate_browser_node(
                 "%d" % (group.id), None,
-                group.name,
+                group.name + ' (' + str(servers.count()) + ')',
                 "icon-%s" % self.node_type,
                 True,
                 self.node_type,
diff --git a/web/pgadmin/browser/server_groups/servers/databases/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/__init__.py
index 3b7c57b..cf76523 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/__init__.py
@@ -30,6 +30,45 @@ from pgadmin.utils.driver import get_driver
 from config import PG_DEFAULT_DRIVER
 
 
+def check_precondition(action=None):
+    """
+    This function will behave as a decorator which will checks
+    database connection before running view, it will also attaches
+    manager,conn & template_path properties to self
+    """
+
+    def wrap(f):
+        @wraps(f)
+        def wrapped(self, *args, **kwargs):
+
+            self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(kwargs['sid'])
+            if action and action in ["drop"]:
+                self.conn = self.manager.connection()
+            elif 'did' in kwargs:
+                self.conn = self.manager.connection(did=kwargs['did'])
+            else:
+                self.conn = self.manager.connection()
+            # If DB not connected then return error to browser
+            if not self.conn.connected():
+                return precondition_required(
+                    _("Connection to the server has been lost!")
+                )
+
+            ver = self.manager.version
+            # we will set template path for sql scripts
+            if ver >= 90300:
+                self.template_path = 'databases/sql/9.3_plus'
+            elif ver >= 90200:
+                self.template_path = 'databases/sql/9.2_plus'
+            else:
+                self.template_path = 'databases/sql/9.1_plus'
+            return f(self, *args, **kwargs)
+
+        return wrapped
+
+    return wrap
+
+
 class DatabaseModule(CollectionNodeModule):
     NODE_TYPE = 'database'
     COLLECTION_LABEL = _("Databases")
@@ -40,12 +79,28 @@ class DatabaseModule(CollectionNodeModule):
 
         super(DatabaseModule, self).__init__(*args, **kwargs)
 
+    @check_precondition(action="nodes")
     def get_nodes(self, gid, sid):
         """
         Generate the collection node
         """
         if self.show_node:
-            yield self.generate_browser_collection_node(sid)
+            collection_count = 0
+            last_system_oid = 0 if self.show_system_objects else \
+                (self.manager.db_info[self.manager.did])['datlastsysoid']
+
+            count_sql = 'SELECT count(*) FROM( '
+            node_sql = render_template(
+                "/".join([self.template_path, 'nodes.sql']),
+                last_system_oid=last_system_oid
+            )
+            count_sql += node_sql + ' ) AS collection_count'
+
+            status, rset = self.conn.execute_scalar(count_sql)
+            if status:
+                collection_count = rset
+
+            yield self.generate_browser_collection_node(sid, collection_count)
 
     @property
     def script_load(self):
@@ -111,47 +166,10 @@ class DatabaseView(PGChildNodeView):
         }],
         'get_encodings': [{'get': 'get_encodings'}, {'get': 'get_encodings'}],
         'get_ctypes': [{'get': 'get_ctypes'}, {'get': 'get_ctypes'}],
-        'vopts': [{}, {'get': 'variable_options'}]
+        'vopts': [{}, {'get': 'variable_options'}],
+        'coll': [{}, {'get': 'collection'}]
     })
 
-    def check_precondition(action=None):
-        """
-        This function will behave as a decorator which will checks
-        database connection before running view, it will also attaches
-        manager,conn & template_path properties to self
-        """
-
-        def wrap(f):
-            @wraps(f)
-            def wrapped(self, *args, **kwargs):
-
-                self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(kwargs['sid'])
-                if action and action in ["drop"]:
-                    self.conn = self.manager.connection()
-                elif 'did' in kwargs:
-                    self.conn = self.manager.connection(did=kwargs['did'])
-                else:
-                    self.conn = self.manager.connection()
-                # If DB not connected then return error to browser
-                if not self.conn.connected():
-                    return precondition_required(
-                        _("Connection to the server has been lost!")
-                    )
-
-                ver = self.manager.version
-                # we will set template path for sql scripts
-                if ver >= 90300:
-                    self.template_path = 'databases/sql/9.3_plus'
-                elif ver >= 90200:
-                    self.template_path = 'databases/sql/9.2_plus'
-                else:
-                    self.template_path = 'databases/sql/9.1_plus'
-                return f(self, *args, **kwargs)
-
-            return wrapped
-
-        return wrap
-
     @check_precondition(action="list")
     def list(self, gid, sid):
         last_system_oid = 0 if self.blueprint.show_system_objects else \
diff --git a/web/pgadmin/browser/server_groups/servers/databases/casts/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/casts/__init__.py
index 86a7eca..a5e2f38 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/casts/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/casts/__init__.py
@@ -25,6 +25,36 @@ from pgadmin.utils.driver import get_driver
 from config import PG_DEFAULT_DRIVER
 
 
+def check_precondition(f):
+    """
+    This function will behave as a decorator which will check the
+    database connection before running view. It will also attach
+    manager, conn & template_path properties to self
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        # Here args[0] will hold self & kwargs will hold gid,sid,did
+        self = args[0]
+        self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(kwargs['sid'])
+        self.conn = self.manager.connection(did=kwargs['did'])
+        # If DB not connected then return error to browser
+        if not self.conn.connected():
+            return precondition_required(
+                gettext(
+                    "Connection to the server has been lost!"
+                )
+            )
+        ver = self.manager.version
+        # we will set template path for sql scripts
+        if ver >= 90100:
+            self.template_path = 'cast/sql/9.1_plus'
+
+        return f(*args, **kwargs)
+
+    return wrap
+
+
 class CastModule(CollectionNodeModule):
     """
      class CastModule(CollectionNodeModule)
@@ -53,6 +83,7 @@ class CastModule(CollectionNodeModule):
     def __init__(self, *args, **kwargs):
         super(CastModule, self).__init__(*args, **kwargs)
 
+    @check_precondition
     def get_nodes(self, gid, sid, did):
         """
         Generate the collection node
@@ -60,7 +91,23 @@ class CastModule(CollectionNodeModule):
         :param sid: server id
         :param did: database id
         """
-        yield self.generate_browser_collection_node(did)
+        collection_count = 0
+        last_system_oid = 0 if self.show_system_objects else \
+            (self.manager.db_info[self.manager.did])['datlastsysoid']
+
+        count_sql = 'SELECT count(*) FROM( '
+        node_sql = render_template(
+            "/".join([self.template_path, 'nodes.sql']),
+            datlastsysoid=self.manager.db_info[did]['datlastsysoid'],
+            showsysobj=self.show_system_objects
+        )
+        count_sql += node_sql + ' ) AS collection_count'
+
+        status, rset = self.conn.execute_scalar(count_sql)
+        if status:
+            collection_count = rset
+
+        yield self.generate_browser_collection_node(did, collection_count)
 
     @property
     def node_inode(self):
@@ -188,35 +235,6 @@ class CastView(PGChildNodeView):
             200, {'Content-Type': 'application/x-javascript'}
         )
 
-    def check_precondition(f):
-        """
-        This function will behave as a decorator which will check the
-        database connection before running view. It will also attach
-        manager, conn & template_path properties to self
-        """
-
-        @wraps(f)
-        def wrap(*args, **kwargs):
-            # Here args[0] will hold self & kwargs will hold gid,sid,did
-            self = args[0]
-            self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(kwargs['sid'])
-            self.conn = self.manager.connection(did=kwargs['did'])
-            # If DB not connected then return error to browser
-            if not self.conn.connected():
-                return precondition_required(
-                    gettext(
-                        "Connection to the server has been lost!"
-                    )
-                )
-            ver = self.manager.version
-            # we will set template path for sql scripts
-            if ver >= 90100:
-                self.template_path = 'cast/sql/9.1_plus'
-
-            return f(*args, **kwargs)
-
-        return wrap
-
     @check_precondition
     def list(self, gid, sid, did):
         """
diff --git a/web/pgadmin/browser/server_groups/servers/databases/event_triggers/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/event_triggers/__init__.py
index 9f434e1..9c625b2 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/event_triggers/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/event_triggers/__init__.py
@@ -24,6 +24,37 @@ from pgadmin.utils.driver import get_driver
 from config import PG_DEFAULT_DRIVER
 
 
+def check_precondition(f):
+    """
+    This function will behave as a decorator which will checks
+    database connection before running view, it will also attaches
+    manager,conn & template_path properties to self
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        # Here args[0] will hold self & kwargs will hold gid,sid,did
+        self = args[0]
+        self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(kwargs['sid'])
+        self.conn = self.manager.connection(did=kwargs['did'])
+
+        # If DB not connected then return error to browser
+        if not self.conn.connected():
+            return precondition_required(
+                gettext(
+                    "Connection to the server has been lost!"
+                )
+            )
+
+        ver = self.manager.version
+        if ver >= 90300:
+            self.template_path = 'event_triggers/sql/9.3_plus'
+
+        return f(*args, **kwargs)
+
+    return wrap
+
+
 class EventTriggerModule(CollectionNodeModule):
     """
     class EventTriggerModule(CollectionNodeModule)
@@ -59,11 +90,22 @@ class EventTriggerModule(CollectionNodeModule):
         self.min_ver = 90300
         self.max_ver = None
 
+    @check_precondition
     def get_nodes(self, gid, sid, did):
         """
         Generate the event_trigger node
         """
-        yield self.generate_browser_collection_node(sid)
+        collection_count = 0
+
+        count_sql = 'SELECT count(*) FROM( '
+        node_sql = render_template("/".join([self.template_path, 'nodes.sql']))
+        count_sql += node_sql + ' ) AS collection_count'
+
+        status, rset = self.conn.execute_scalar(count_sql)
+        if status:
+            collection_count = rset
+
+        yield self.generate_browser_collection_node(sid, collection_count)
 
     @property
     def node_inode(self):
@@ -179,35 +221,6 @@ class EventTriggerView(PGChildNodeView):
             200, {'Content-Type': 'application/x-javascript'}
         )
 
-    def check_precondition(f):
-        """
-        This function will behave as a decorator which will checks
-        database connection before running view, it will also attaches
-        manager,conn & template_path properties to self
-        """
-
-        @wraps(f)
-        def wrap(*args, **kwargs):
-            # Here args[0] will hold self & kwargs will hold gid,sid,did
-            self = args[0]
-            self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(kwargs['sid'])
-            self.conn = self.manager.connection(did=kwargs['did'])
-
-            # If DB not connected then return error to browser
-            if not self.conn.connected():
-                return precondition_required(
-                    gettext(
-                        "Connection to the server has been lost!"
-                    )
-                )
-
-            ver = self.manager.version
-            if ver >= 90300:
-                self.template_path = 'event_triggers/sql/9.3_plus'
-
-            return f(*args, **kwargs)
-
-        return wrap
 
     @check_precondition
     def list(self, gid, sid, did):
diff --git a/web/pgadmin/browser/server_groups/servers/databases/extensions/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/extensions/__init__.py
index 888393c..aff15a0 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/extensions/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/extensions/__init__.py
@@ -45,6 +45,28 @@ else:
     basestring = basestring
 
 
+def check_precondition(f):
+    """
+    This function will behave as a decorator which will checks
+    database connection before running view, it will also attaches
+    manager,conn & template_path properties to self
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        # Here args[0] will hold self & kwargs will hold gid,sid,did
+        self = args[0]
+        self.manager = get_driver(
+            PG_DEFAULT_DRIVER
+        ).connection_manager(kwargs['sid'])
+        self.conn = self.manager.connection(did=kwargs['did'])
+        self.template_path = 'extensions/sql'
+
+        return f(*args, **kwargs)
+
+    return wrap
+
+
 class ExtensionModule(CollectionNodeModule):
     """
     class ExtensionModule(Object):
@@ -62,11 +84,22 @@ class ExtensionModule(CollectionNodeModule):
         """
         super(ExtensionModule, self).__init__(*args, **kwargs)
 
+    @check_precondition
     def get_nodes(self, gid, sid, did):
         """
         Generate the collection node
         """
-        yield self.generate_browser_collection_node(did)
+        collection_count = 0
+
+        count_sql = 'SELECT count(*) FROM( '
+        node_sql = render_template("/".join([self.template_path, 'properties.sql']))
+        count_sql += node_sql + ' ) AS collection_count'
+
+        status, rset = self.conn.execute_scalar(count_sql)
+        if status:
+            collection_count = rset
+
+        yield self.generate_browser_collection_node(did, collection_count)
 
     @property
     def node_inode(self):
@@ -130,27 +163,6 @@ class ExtensionView(PGChildNodeView):
         'children': [{'get': 'children'}]
     })
 
-    def check_precondition(f):
-        """
-        This function will behave as a decorator which will checks
-        database connection before running view, it will also attaches
-        manager,conn & template_path properties to self
-        """
-
-        @wraps(f)
-        def wrap(*args, **kwargs):
-            # Here args[0] will hold self & kwargs will hold gid,sid,did
-            self = args[0]
-            self.manager = get_driver(
-                PG_DEFAULT_DRIVER
-            ).connection_manager(kwargs['sid'])
-            self.conn = self.manager.connection(did=kwargs['did'])
-            self.template_path = 'extensions/sql'
-
-            return f(*args, **kwargs)
-
-        return wrap
-
     @check_precondition
     def list(self, gid, sid, did):
         """
diff --git a/web/pgadmin/browser/server_groups/servers/databases/foreign_data_wrappers/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/foreign_data_wrappers/__init__.py
index d4494a1..3edb755 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/foreign_data_wrappers/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/foreign_data_wrappers/__init__.py
@@ -27,6 +27,40 @@ from pgadmin.utils.driver import get_driver
 from config import PG_DEFAULT_DRIVER
 
 
+def check_precondition(f):
+    """
+    This function will behave as a decorator which will checks
+    database connection before running view, it will also attaches
+    manager,conn & template_path properties to self
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        # Here args[0] will hold self & kwargs will hold gid,sid,did
+        self = args[0]
+        self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(kwargs['sid'])
+        self.conn = self.manager.connection(did=kwargs['did'])
+
+        # If DB not connected then return error to browser
+        if not self.conn.connected():
+            return precondition_required(
+                gettext(
+                    "Connection to the server has been lost!"
+                )
+            )
+
+        ver = self.manager.version
+        # we will set template path for sql scripts
+        if ver >= 90300:
+            self.template_path = 'foreign_data_wrappers/sql/9.3_plus'
+        else:
+            self.template_path = 'foreign_data_wrappers/sql/9.1_plus'
+
+        return f(*args, **kwargs)
+
+    return wrap
+
+
 class ForeignDataWrapperModule(CollectionNodeModule):
     """
     class ForeignDataWrapperModule(CollectionNodeModule)
@@ -63,6 +97,7 @@ class ForeignDataWrapperModule(CollectionNodeModule):
 
         super(ForeignDataWrapperModule, self).__init__(*args, **kwargs)
 
+    @check_precondition
     def get_nodes(self, gid, sid, did):
         """
         Method is used to generate the browser collection node
@@ -72,7 +107,17 @@ class ForeignDataWrapperModule(CollectionNodeModule):
             sid: Server ID
             did: Database Id
         """
-        yield self.generate_browser_collection_node(did)
+        collection_count = 0
+
+        count_sql = 'SELECT count(*) FROM( '
+        node_sql = render_template("/".join([self.template_path, 'properties.sql']), conn=self.conn)
+        count_sql += node_sql + ' ) AS collection_count'
+
+        status, rset = self.conn.execute_scalar(count_sql)
+        if status:
+            collection_count = rset
+
+        yield self.generate_browser_collection_node(did, collection_count)
 
     @property
     def script_load(self):
@@ -197,39 +242,6 @@ class ForeignDataWrapperView(PGChildNodeView):
             200, {'Content-Type': 'application/x-javascript'}
         )
 
-    def check_precondition(f):
-        """
-        This function will behave as a decorator which will checks
-        database connection before running view, it will also attaches
-        manager,conn & template_path properties to self
-        """
-
-        @wraps(f)
-        def wrap(*args, **kwargs):
-            # Here args[0] will hold self & kwargs will hold gid,sid,did
-            self = args[0]
-            self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(kwargs['sid'])
-            self.conn = self.manager.connection(did=kwargs['did'])
-
-            # If DB not connected then return error to browser
-            if not self.conn.connected():
-                return precondition_required(
-                    gettext(
-                        "Connection to the server has been lost!"
-                    )
-                )
-
-            ver = self.manager.version
-            # we will set template path for sql scripts
-            if ver >= 90300:
-                self.template_path = 'foreign_data_wrappers/sql/9.3_plus'
-            else:
-                self.template_path = 'foreign_data_wrappers/sql/9.1_plus'
-
-            return f(*args, **kwargs)
-
-        return wrap
-
     @check_precondition
     def list(self, gid, sid, did):
         """
diff --git a/web/pgadmin/browser/server_groups/servers/databases/foreign_data_wrappers/foreign_servers/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/foreign_data_wrappers/foreign_servers/__init__.py
index f51975f..8cdf7a3 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/foreign_data_wrappers/foreign_servers/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/foreign_data_wrappers/foreign_servers/__init__.py
@@ -27,6 +27,40 @@ from pgadmin.utils.driver import get_driver
 from config import PG_DEFAULT_DRIVER
 
 
+def check_precondition(f):
+    """
+    This function will behave as a decorator which will checks
+    database connection before running view, it will also attaches
+    manager,conn & template_path properties to self
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        # Here args[0] will hold self & kwargs will hold gid,sid,did
+        self = args[0]
+        self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(kwargs['sid'])
+        self.conn = self.manager.connection(did=kwargs['did'])
+
+        # If DB not connected then return error to browser
+        if not self.conn.connected():
+            return precondition_required(
+                gettext(
+                    "Connection to the server has been lost!"
+                )
+            )
+
+        ver = self.manager.version
+        # we will set template path for sql scripts
+        if ver >= 90300:
+            self.template_path = 'foreign_servers/sql/9.3_plus'
+        else:
+            self.template_path = 'foreign_servers/sql/9.1_plus'
+
+        return f(*args, **kwargs)
+
+    return wrap
+
+
 class ForeignServerModule(CollectionNodeModule):
     """
     class ForeignServerModule(CollectionNodeModule)
@@ -63,6 +97,7 @@ class ForeignServerModule(CollectionNodeModule):
 
         super(ForeignServerModule, self).__init__(*args, **kwargs)
 
+    @check_precondition
     def get_nodes(self, gid, sid, did, fid):
         """
         Method is used to generate the browser collection node
@@ -73,7 +108,18 @@ class ForeignServerModule(CollectionNodeModule):
             did: Database ID
             fid: foreign data wrapper ID
         """
-        yield self.generate_browser_collection_node(fid)
+        collection_count = 0
+
+        count_sql = 'SELECT count(*) FROM( '
+        node_sql = render_template("/".join([self.template_path, 'properties.sql']),
+                                   conn=self.conn, fid=fid)
+        count_sql += node_sql + ' ) AS collection_count'
+
+        status, rset = self.conn.execute_scalar(count_sql)
+        if status:
+            collection_count = rset
+
+        yield self.generate_browser_collection_node(fid, collection_count)
 
     @property
     def script_load(self):
@@ -191,39 +237,6 @@ class ForeignServerView(PGChildNodeView):
             200, {'Content-Type': 'application/x-javascript'}
         )
 
-    def check_precondition(f):
-        """
-        This function will behave as a decorator which will checks
-        database connection before running view, it will also attaches
-        manager,conn & template_path properties to self
-        """
-
-        @wraps(f)
-        def wrap(*args, **kwargs):
-            # Here args[0] will hold self & kwargs will hold gid,sid,did
-            self = args[0]
-            self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(kwargs['sid'])
-            self.conn = self.manager.connection(did=kwargs['did'])
-
-            # If DB not connected then return error to browser
-            if not self.conn.connected():
-                return precondition_required(
-                    gettext(
-                        "Connection to the server has been lost!"
-                    )
-                )
-
-            ver = self.manager.version
-            # we will set template path for sql scripts
-            if ver >= 90300:
-                self.template_path = 'foreign_servers/sql/9.3_plus'
-            else:
-                self.template_path = 'foreign_servers/sql/9.1_plus'
-
-            return f(*args, **kwargs)
-
-        return wrap
-
     @check_precondition
     def list(self, gid, sid, did, fid):
         """
diff --git a/web/pgadmin/browser/server_groups/servers/databases/foreign_data_wrappers/foreign_servers/user_mapping/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/foreign_data_wrappers/foreign_servers/user_mapping/__init__.py
index c0e3f58..09762ec 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/foreign_data_wrappers/foreign_servers/user_mapping/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/foreign_data_wrappers/foreign_servers/user_mapping/__init__.py
@@ -25,6 +25,40 @@ from pgadmin.utils.driver import get_driver
 from config import PG_DEFAULT_DRIVER
 
 
+def check_precondition(f):
+    """
+    This function will behave as a decorator which will checks
+    database connection before running view, it will also attaches
+    manager,conn & template_path properties to self
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        # Here args[0] will hold self & kwargs will hold gid,sid,did
+        self = args[0]
+        self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(kwargs['sid'])
+        self.conn = self.manager.connection(did=kwargs['did'])
+
+        # If DB not connected then return error to browser
+        if not self.conn.connected():
+            return precondition_required(
+                gettext(
+                    "Connection to the server has been lost!"
+                )
+            )
+
+        self.template_path = 'user_mappings/sql/9.1_plus'
+
+        ver = self.manager.version
+        # we will set template path for sql scripts
+        if ver >= 90100:
+            self.template_path = 'user_mappings/sql/9.1_plus'
+
+        return f(*args, **kwargs)
+
+    return wrap
+
+
 class UserMappingModule(CollectionNodeModule):
     """
     class UserMappingModule(CollectionNodeModule)
@@ -64,6 +98,7 @@ class UserMappingModule(CollectionNodeModule):
 
         super(UserMappingModule, self).__init__(*args, **kwargs)
 
+    @check_precondition
     def get_nodes(self, gid, sid, did, fid, fsid):
         """
         Method is used to generate the browser collection node
@@ -75,8 +110,18 @@ class UserMappingModule(CollectionNodeModule):
             fid: foreign data wrapper ID
             fsid: Foreign server ID
         """
+        collection_count = 0
+
+        count_sql = 'SELECT count(*) FROM( '
+        node_sql = render_template("/".join([self.template_path, 'properties.sql']),
+                                   conn=self.conn, fsid=fsid)
+        count_sql += node_sql + ' ) AS collection_count'
+
+        status, rset = self.conn.execute_scalar(count_sql)
+        if status:
+            collection_count = rset
 
-        yield self.generate_browser_collection_node(fsid)
+        yield self.generate_browser_collection_node(fsid, collection_count)
 
     @property
     def node_inode(self):
@@ -205,39 +250,6 @@ class UserMappingView(PGChildNodeView):
             200, {'Content-Type': 'application/x-javascript'}
         )
 
-    def check_precondition(f):
-        """
-        This function will behave as a decorator which will checks
-        database connection before running view, it will also attaches
-        manager,conn & template_path properties to self
-        """
-
-        @wraps(f)
-        def wrap(*args, **kwargs):
-            # Here args[0] will hold self & kwargs will hold gid,sid,did
-            self = args[0]
-            self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(kwargs['sid'])
-            self.conn = self.manager.connection(did=kwargs['did'])
-
-            # If DB not connected then return error to browser
-            if not self.conn.connected():
-                return precondition_required(
-                    gettext(
-                        "Connection to the server has been lost!"
-                    )
-                )
-
-            self.template_path = 'user_mappings/sql/9.1_plus'
-
-            ver = self.manager.version
-            # we will set template path for sql scripts
-            if ver >= 90100:
-                self.template_path = 'user_mappings/sql/9.1_plus'
-
-            return f(*args, **kwargs)
-
-        return wrap
-
     @check_precondition
     def list(self, gid, sid, did, fid, fsid):
         """
